#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <io.h>

typedef struct STEXTPOStag{
	int	 x;
	int	 y;
	int	 width;
	int	 height;
	char text[500];
}STEXTPOS;

#pragma comment( lib, "../lib/i2pocrsdk.lib" )

__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_GetTextInfo(char *lpszPDFFile, LPBYTE *lpChars, char *lpszOptions);
__declspec(dllexport) void   WINAPI Image2PDFOCR_SinglePage_FreeTextInfo(LPBYTE lpChars);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_CreatePDF(char *lpszInPDFFile, LPBYTE lpChars, int nCharCount, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_PDFCmd(char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreateSearchablePDF(const char *lpTIFOrPDFFile, const char *lpOutputFile, const char *lpOptions);

__declspec(dllexport) HANDLE WINAPI Image2PDFOCR_GetTextHandle(char *lpszTIFOrPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetOCRedPageCount(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE *lpOutTextInfo);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE lpInTextInfo, int nCharNum);
__declspec(dllexport) void   WINAPI Image2PDFOCR_FreeTextHandle(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDF(HANDLE hImage2PDFData, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDFInMemory(HANDLE hImage2PDFData, char *lpszOptions, LPBYTE *lpDataBuf, int *nDataBufLen);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetPageCount(char *lpszPDFFile);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordCountOnPage(HANDLE hImage2PDFData, int nPage);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int *X, int *Y, int *Width, int *Height, char *lpText);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_SetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int X, int Y, int Width, int Height, char *lpText);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

int main(int argc, char *argv[])
{
	if(argc != 3)
	{
		printf("\"%s\" test.pdf out.pdf\n", argv[0]);
		printf("\"%s\" test.tif out.pdf\n", argv[0]);
		return 0;
	}
	int nRet = 0;
	//Example #3: Get Text Information first, you can modify OCRed text result, and create searchable PDF file again
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		strcpy(szInFile, argv[1]);
		strcpy(szOutFile, argv[2]);

		int nPageCount = Image2PDFOCR_GetPageCount(szInFile);
		printf("'%s' file contains '%d' pages.\n", szInFile, nPageCount);
		HANDLE hOCRTextSDK = Image2PDFOCR_GetTextHandle(szInFile, "-pidpi 300");
		if(hOCRTextSDK)
		{
			int nPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
			for(int page = 0; page < nPageCount; page++)
			{
				LPBYTE lpChars = NULL;
				int nCharCount = Image2PDFOCR_GetTextInfo(hOCRTextSDK, page, &lpChars);
				STEXTPOS *lpTextPos = (STEXTPOS*)lpChars;
				for(int i = 0; i < nCharCount; i++)
				{
					printf("%d,%d,%d,%d,%s\n", lpTextPos[i].x, lpTextPos[i].y, lpTextPos[i].width, lpTextPos[i].height, lpTextPos[i].text);
				}
				Image2PDFOCR_SetTextInfo(hOCRTextSDK, page, lpChars, nCharCount);
			}
			nRet = Image2PDFOCR_CreatePDF(hOCRTextSDK, szOutFile, "-pidpi 300");
			Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
		}
		printf("Example return '%d'\n", nRet);
	}
	return nRet;
}